#!/usr/bin/env python3
from gi.repository import GLib
from pydbus import SystemBus
import os
import getpass
import socket
import subprocess
import time
import dbus
import dbus.service
import dbus.mainloop.glib
import os

from kdk_accessctl import kyaccessctl
from kysdk_logsec import kylog

from dbus.mainloop.glib import DBusGMainLoop
DBusGMainLoop(set_as_default=True)

bus2=SystemBus()
loop = GLib.MainLoop()

BUS_NAME = "com.kylin.kysdk.PhoneControl"
BUS_PATH = "/com/kylin/kysdk/PhoneControl"
BUS_IFACE = "com.kylin.kysdk.PhoneControl"

def get_host_name():
    """获取当前用户名"""
    username = getpass.getuser()
    return  username

def get_host_time():
    """获取本机时间
    return: time_1
    """
    time_1=time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
    return time_1

def get_host_ip():
    """
    查询本机ip地址
    :return: ip
    """
    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        s.connect(('8.8.8.8', 80))
        ip = s.getsockname()[0]
    except Exception:
        return "127.0.0.1"
    return ip
class PhoneService(dbus.service.Object):
    """
        <node>
            <interface name='com.kylin.kysdk.PhoneControl'>
                <method name='GetStatus'>
                <arg type='i' name='status' direction='out'/>
                </method>
                <method name='SetStatus'>
                <arg type='i' name='status' direction='in'/>
                <arg type='i' name='ret' direction='out'/>
                </method>
            </interface>
        </node>
    """

    def __init__(self):
        bus = dbus.SystemBus()
        bus_name = dbus.service.BusName(BUS_NAME, bus=bus)
        dbus.service.Object.__init__(self, bus_name, BUS_PATH)

    @dbus.service.method(dbus_interface=BUS_IFACE, in_signature="", out_signature="i", sender_keyword='sender')
    def GetStatus(self, sender=None):
        kylog.KdkSecLog().kdklog_dbus_call(sender, kylog.KdkLogModule.KDK_MODULE_DESKTOP.value, BUS_NAME, BUS_PATH, BUS_IFACE, "GetStatus")
        rc = kyaccessctl.KdkAccessCtl().kdk_accessctl_check_callable(sender, 
        kyaccessctl.KdkModuleType.KDK_MODULE_DESKTOP.value)
        if(rc == kyaccessctl.KdkAccessCtlStatus.KDK_ACCESSCTL_DISABLE.value):
            kylog.KdkSecLog().kdklog_dbus_exit(sender, kylog.KdkLogModule.KDK_MODULE_DESKTOP.value, BUS_NAME, BUS_PATH, BUS_IFACE, "GetStatus")
            return kyaccessctl.KdkAccessCtlErrnoStatus.KDK_ERRNO_ACCESSCTL_DENY.value

        if os.path.exists('/etc/phone.perm') & os.path.exists('/etc/read.perm'):
            rc = 2
        elif os.path.exists('/etc/phone.perm') &(not os.path.exists('/etc/read.perm')):
            rc = 1
        elif not (os.path.exists('/etc/phone.perm') or os.path.exists('/etc/read.perm')):
            rc = 0

        kylog.KdkSecLog().kdklog_dbus_exit(sender, kylog.KdkLogModule.KDK_MODULE_DESKTOP.value, BUS_NAME, BUS_PATH, BUS_IFACE, "GetStatus")
        return rc

    @dbus.service.method(dbus_interface=BUS_IFACE, in_signature="i", out_signature="i", sender_keyword='sender')
    def SetStatus(self, status: int, sender=None):
        kylog.KdkSecLog().kdklog_dbus_call(sender, kylog.KdkLogModule.KDK_MODULE_DESKTOP.value, BUS_NAME, BUS_PATH, BUS_IFACE, "SetStatus")
        rc = kyaccessctl.KdkAccessCtl().kdk_accessctl_check_callable(sender, 
        kyaccessctl.KdkModuleType.KDK_MODULE_DESKTOP.value)
        if(rc == kyaccessctl.KdkAccessCtlStatus.KDK_ACCESSCTL_DISABLE.value):
            kylog.KdkSecLog().kdklog_dbus_exit(sender, kylog.KdkLogModule.KDK_MODULE_DESKTOP.value, BUS_NAME, BUS_PATH, BUS_IFACE, "SetStatus")
            return kyaccessctl.KdkAccessCtlErrnoStatus.KDK_ERRNO_ACCESSCTL_DENY.value
            
        if status ==0:
            if os.path.exists('/etc/phone.perm'):
                os.remove('/etc/phone.perm')
            if os.path.exists('/etc/read.perm'):
                os.remove('/etc/read.perm')
            try:
                os.system("pkill gvfsd-mtp")
                os.system("pkill gvfsd-gphoto2")
            except:
                rc = -1
            rc = 0
        elif status == 1:
            if os.path.exists('/etc/read.perm'):
                os.remove('/etc/read.perm')
            with open('/etc/phone.perm','w') as f:
                f.write('1')
            rc = 0
        elif status== 2:
            with open('/etc/phone.perm','w') as f:
                f.write('1')
            with open('/etc/read.perm', 'w') as f:
                f.write('1')
            rc = 0
        else:
            rc = -1

        kylog.KdkSecLog().kdklog_dbus_exit(sender, kylog.KdkLogModule.KDK_MODULE_DESKTOP.value, BUS_NAME, BUS_PATH, BUS_IFACE, "SetStatus")
        return rc

if __name__ == '__main__':
    loop = GLib.MainLoop()
    bus = dbus.SystemBus()
    bus.request_name(BUS_NAME)
    PhoneService()
    loop.run()